#ifndef PLASMKEYWORDS_H
#define PLASMKEYWORDS_H

#include <qstring.h>
#include <qmap.h>

// Single keyword handler
class KeyWord
{
public:
        KeyWord();
        KeyWord(QString, QString, QString, QString, QString);
        ~KeyWord();

        void setName(QString);
        void setLibrary(QString);
        void setInput(QString);
        void setOutput(QString);
        void setDescription(QString);
        QString getName();
        QString getLibrary();
        QString getInput();
        QString getOutput();
        QString getDescription();
private:
        QString keywordName;
        QString keywordLibrary;
        QString keywordInput;
        QString keywordOutput;
        QString keywordDescription;
};

// Holds the keywords with name, input and output parameters, description
class PlasmKeywords
{
public:
    PlasmKeywords();
    ~PlasmKeywords();

    QMap<QString, KeyWord*> db;
};

#endif
