#include "xplodedefinitions.h"
#include "xplodeshared.h"
#include "xplodeicons.h"

XplodeDefinitions::XplodeDefinitions(QWidget *parent, const char *name) : QListBox(parent, name)
{
        setAcceptDrops(true);
        viewport()->setAcceptDrops(true);
}

void XplodeDefinitions::contentsMousePressEvent(QMouseEvent *event)
{
        // Store the drag position
        if (event->button() == LeftButton)
                dragPos = event->pos();
        QListBox::contentsMousePressEvent(event);
}

void XplodeDefinitions::contentsMouseMoveEvent(QMouseEvent *event)
{
        // Are we still pressing the left button?
        if (event->state() & LeftButton)
                startDrag();
        QListBox::contentsMouseMoveEvent(event);
}

void XplodeDefinitions::startDrag()
{
        // Get the selected text
        QString text = currentText();
        if (!text.isEmpty())
        {
                // Create the drag item
                QTextDrag *dragText = new QTextDrag(text, this);
                // Cool pixmap
                if (QString(name()) == "def")
                {
                        // User definition
                        dragText->setPixmap(QPixmap(qembed_findImage("plasmevalexpr")));
                }
                else
                {
                        // Exported file
                        dragText->setPixmap(QPixmap(qembed_findImage("filenew")));
                }
                dragText->dragCopy();
        }
}

void XplodeDefinitions::contentsDragEnterEvent (QDragEnterEvent *event)
{
        if (event->source() == this)
                event->ignore();
        else
                event->accept();
}

void XplodeDefinitions::contentsDragMoveEvent (QDragMoveEvent *event)
{
        if (event->source() == this)
                event->ignore();
        else
                event->accept();
}

void XplodeDefinitions::contentsDropEvent (QDropEvent *event)
{
        if (event->source() == this)
                event->ignore();
        else
        {
                QString text;

                if (QTextDrag::decode(event, text))
                {
                        emit dropped(text);
                }
                event->accept();
        }
}
